#include "chdecl.h"
void CH_codegen_cgif(current, sched, cop)
#define ARGUMENTS 5
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb1;
    case 2: goto c2;
    case 3: goto cb3;
    case 4: goto c4;
    case 5: goto cb21;
    case 6: goto c22;
    case 7: goto cb33;
    case 8: goto c34;
    case 9: goto cb50;
    case 10: goto c51;
    case 11: goto c53;
    case 12: goto c68;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 1;
cb1:
/* receive 3 0 */
  if ((ch_returncode = che_receive(DEF(3),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c2:
/* reveal 3.0.3 , 7 */
  if (7 != REF(3)DOT(0)DOT(3).value.variant->info.variant_case)
     goto ch_case_error;
  current->ip = 3;
cb3:
/* call 3.2.3.2 3.0.3.0.0 3.2 , 1 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(2)DOT(3)DOT(2),
          arguments[1] = DEF(3)DOT(0)DOT(3)DOT(0)DOT(0),
          arguments[2] = DEF(3)DOT(2),
          arguments[2+1] = nil,& arguments[0]),QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  return;
c4:
/* unique 4 */
  if ((ch_returncode = che_unique(DEF(4),sched)) != Normal)
     goto ch_raise_exception;
/* unique 5 */
  if ((ch_returncode = che_unique(DEF(5),sched)) != Normal)
     goto ch_raise_exception;
/* case 6 3.0.3.0.3 */
  REF(6).value.enumeration = REF(3)DOT(0)DOT(3)DOT(0)DOT(3).value.variant
    ->info.variant_case;
  REF(6).tsdr = & dr_enumeration;
/* notequal . 6 =(0) , 15 */
  if ( REF(6).value.enumeration != 0 ) goto c15;
/* unique 7 */
  if ((ch_returncode = che_unique(DEF(7),sched)) != Normal)
     goto ch_raise_exception;
/* branch , 16 */
   goto c16;
c15:
/* copy 7 5 */
  if((ch_returncode = cp_nominal(& ch_val, REF(5).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(7).tsdr)->finalize)(REF(7).value,F_DISCARD,sched);
  REF(7).value = ch_val;
  REF(7).tsdr = & dr_nominal;
c16:
/* new_record 8 , 2 */
  if ((ch_val.record = new_record(2)) == nil) goto ch_depletion;
  (*(REF(8).tsdr)->finalize)(REF(8).value,F_DISCARD,sched);
  REF(8).value = ch_val; REF(8).tsdr = & dr_record;
/* copy 8.0 4 */
  if((ch_returncode = cp_nominal(& ch_val, REF(4).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(8)DOT(0).tsdr)->finalize)(REF(8)DOT(0).value,F_DISCARD,sched);
  REF(8)DOT(0).value = ch_val;
  REF(8)DOT(0).tsdr = & dr_nominal;
/* copy 8.1 7 */
  if((ch_returncode = cp_nominal(& ch_val, REF(7).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(8)DOT(1).tsdr)->finalize)(REF(8)DOT(1).value,F_DISCARD,sched);
  REF(8)DOT(1).value = ch_val;
  REF(8)DOT(1).tsdr = & dr_nominal;
/* unite 3.2.4.3.2 8 , 1 */
  if ((ch_returncode = che_unite(DEF(3)DOT(2)DOT(4)DOT(3)DOT(2),DEF(8),sched,1
    )) != Normal) goto ch_raise_exception;
/* copy 9 3.2.5.2 */
  if((ch_returncode = (REF(3)DOT(2)DOT(5)DOT(2).tsdr->copy)(& ch_val, 
    REF(3)DOT(2)DOT(5)DOT(2).value)) != Normal) goto ch_raise_exception;
  (*(REF(9).tsdr)->finalize)(REF(9).value,F_DISCARD,sched);
  REF(9).value = ch_val;
  REF(9).tsdr = datarepmap[REF(3)DOT(2)DOT(5)DOT(2).tsdr->number];
  current->ip = 5;
cb21:
/* call 3.2.4.4 3.0.3.0.1 10 , 2 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(2)DOT(4)DOT(4),
          arguments[1] = DEF(3)DOT(0)DOT(3)DOT(0)DOT(1),
          arguments[2] = DEF(10),
          arguments[2+1] = nil,& arguments[0]),QUAL(2),sched)) != Normal)
     goto ch_raise_exception;
  return;
c22:
/* insert 9.1 10 */
  if ((ch_returncode = insertfunc(DEF(9)DOT(1),DEF(10),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* insert 3.2.4.3.1 9 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(2)DOT(4)DOT(3)DOT(1),DEF(9)
    ,FALSE,0)) != Normal) goto ch_raise_exception;
/* copy 11 3.2.4.3.0 */
  if((ch_returncode = cp_nominal(& ch_val, 
    REF(3)DOT(2)DOT(4)DOT(3)DOT(0).value)) != Normal) goto ch_raise_exception;
  (*(REF(11).tsdr)->finalize)(REF(11).value,F_DISCARD,sched);
  REF(11).value = ch_val;
  REF(11).tsdr = & dr_nominal;
/* insert 3.2.4.2.2 11 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(2)DOT(4)DOT(2)DOT(2),DEF(11)
    ,FALSE,0)) != Normal) goto ch_raise_exception;
/* insert 3.2.4.2.0 3.2.4.3 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(2)DOT(4)DOT(2)DOT(0),
    DEF(3)DOT(2)DOT(4)DOT(3),FALSE,0)) != Normal) goto ch_raise_exception;
/* new_record 3.2.4.3 , 3 */
  if ((ch_val.record = new_record(3)) == nil) goto ch_depletion;
  (*(REF(3)DOT(2)DOT(4)DOT(3).tsdr)->finalize)(REF(3)DOT(2)DOT(4)DOT(3).value
    ,F_DISCARD,sched);
  REF(3)DOT(2)DOT(4)DOT(3).value = ch_val; REF(3)DOT(2)DOT(4)DOT(3).tsdr
     = & dr_record;
/* move 3.2.4.3.0 4 */
  (*(REF(3)DOT(2)DOT(4)DOT(3)DOT(0).tsdr)->finalize)(
    REF(3)DOT(2)DOT(4)DOT(3)DOT(0).value,F_DISCARD,sched);
  REF(3)DOT(2)DOT(4)DOT(3)DOT(0) = REF(4);
  REF(4).tsdr = & dr_bottom;
/* new_table 3.2.4.3.1 , 3 */
  if ((ch_returncode = che_new_table(DEF(3)DOT(2)DOT(4)DOT(3)DOT(1),QUAL(3)
    ,sched)) != Normal)  goto ch_raise_exception;
/* unite 3.2.4.3.2 12 , 6 */
  if ((ch_returncode = che_unite(DEF(3)DOT(2)DOT(4)DOT(3)DOT(2),DEF(12),sched,
    6)) != Normal) goto ch_raise_exception;
  current->ip = 7;
cb33:
/* call 3.2.3.2 3.0.3.0.2 3.2 , 1 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(2)DOT(3)DOT(2),
          arguments[1] = DEF(3)DOT(0)DOT(3)DOT(0)DOT(2),
          arguments[2] = DEF(3)DOT(2),
          arguments[2+1] = nil,& arguments[0]),QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  return;
c34:
/* copy 13 5 */
  if((ch_returncode = cp_nominal(& ch_val, REF(5).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(13).tsdr)->finalize)(REF(13).value,F_DISCARD,sched);
  REF(13).value = ch_val;
  REF(13).tsdr = & dr_nominal;
/* unite 3.2.4.3.2 13 , 0 */
  if ((ch_returncode = che_unite(DEF(3)DOT(2)DOT(4)DOT(3)DOT(2),DEF(13),sched,
    0)) != Normal) goto ch_raise_exception;
/* case 14 3.0.3.0.3 */
  REF(14).value.enumeration = REF(3)DOT(0)DOT(3)DOT(0)DOT(3).value.variant
    ->info.variant_case;
  REF(14).tsdr = & dr_enumeration;
/* notequal . 14 =(0) , 53 */
  if ( REF(14).value.enumeration != 0 ) goto c53;
/* reveal 3.0.3.0.3 , 0 */
  if (0 != REF(3)DOT(0)DOT(3)DOT(0)DOT(3).value.variant->info.variant_case)
     goto ch_case_error;
/* copy 15 3.2.4.3.0 */
  if((ch_returncode = cp_nominal(& ch_val, 
    REF(3)DOT(2)DOT(4)DOT(3)DOT(0).value)) != Normal) goto ch_raise_exception;
  (*(REF(15).tsdr)->finalize)(REF(15).value,F_DISCARD,sched);
  REF(15).value = ch_val;
  REF(15).tsdr = & dr_nominal;
/* insert 3.2.4.2.2 15 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(2)DOT(4)DOT(2)DOT(2),DEF(15)
    ,FALSE,0)) != Normal) goto ch_raise_exception;
/* insert 3.2.4.2.0 3.2.4.3 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(2)DOT(4)DOT(2)DOT(0),
    DEF(3)DOT(2)DOT(4)DOT(3),FALSE,0)) != Normal) goto ch_raise_exception;
/* new_record 3.2.4.3 , 3 */
  if ((ch_val.record = new_record(3)) == nil) goto ch_depletion;
  (*(REF(3)DOT(2)DOT(4)DOT(3).tsdr)->finalize)(REF(3)DOT(2)DOT(4)DOT(3).value
    ,F_DISCARD,sched);
  REF(3)DOT(2)DOT(4)DOT(3).value = ch_val; REF(3)DOT(2)DOT(4)DOT(3).tsdr
     = & dr_record;
/* move 3.2.4.3.0 7 */
  (*(REF(3)DOT(2)DOT(4)DOT(3)DOT(0).tsdr)->finalize)(
    REF(3)DOT(2)DOT(4)DOT(3)DOT(0).value,F_DISCARD,sched);
  REF(3)DOT(2)DOT(4)DOT(3)DOT(0) = REF(7);
  REF(7).tsdr = & dr_bottom;
/* new_table 3.2.4.3.1 , 3 */
  if ((ch_returncode = che_new_table(DEF(3)DOT(2)DOT(4)DOT(3)DOT(1),QUAL(3)
    ,sched)) != Normal)  goto ch_raise_exception;
/* unite 3.2.4.3.2 12 , 6 */
  if ((ch_returncode = che_unite(DEF(3)DOT(2)DOT(4)DOT(3)DOT(2),DEF(12),sched,
    6)) != Normal) goto ch_raise_exception;
  current->ip = 9;
cb50:
/* call 3.2.3.2 3.0.3.0.3.0 3.2 , 1 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(2)DOT(3)DOT(2),
          arguments[1] = DEF(3)DOT(0)DOT(3)DOT(0)DOT(3)DOT(0),
          arguments[2] = DEF(3)DOT(2),
          arguments[2+1] = nil,& arguments[0]),QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  return;
c51:
/* copy 16 5 */
  if((ch_returncode = cp_nominal(& ch_val, REF(5).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(16).tsdr)->finalize)(REF(16).value,F_DISCARD,sched);
  REF(16).value = ch_val;
  REF(16).tsdr = & dr_nominal;
/* unite 3.2.4.3.2 16 , 0 */
  if ((ch_returncode = che_unite(DEF(3)DOT(2)DOT(4)DOT(3)DOT(2),DEF(16),sched,
    0)) != Normal) goto ch_raise_exception;
c53:
/* discard 7 */
  (*(REF(7).tsdr)->finalize)(REF(7).value,F_DISCARD,sched);
  REF(7).tsdr = & dr_bottom;
/* copy 17 3.2.4.3.0 */
  if((ch_returncode = cp_nominal(& ch_val, 
    REF(3)DOT(2)DOT(4)DOT(3)DOT(0).value)) != Normal) goto ch_raise_exception;
  (*(REF(17).tsdr)->finalize)(REF(17).value,F_DISCARD,sched);
  REF(17).value = ch_val;
  REF(17).tsdr = & dr_nominal;
/* insert 3.2.4.2.2 17 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(2)DOT(4)DOT(2)DOT(2),DEF(17)
    ,FALSE,0)) != Normal) goto ch_raise_exception;
/* insert 3.2.4.2.0 3.2.4.3 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(2)DOT(4)DOT(2)DOT(0),
    DEF(3)DOT(2)DOT(4)DOT(3),FALSE,0)) != Normal) goto ch_raise_exception;
/* new_record 3.2.4.3 , 3 */
  if ((ch_val.record = new_record(3)) == nil) goto ch_depletion;
  (*(REF(3)DOT(2)DOT(4)DOT(3).tsdr)->finalize)(REF(3)DOT(2)DOT(4)DOT(3).value
    ,F_DISCARD,sched);
  REF(3)DOT(2)DOT(4)DOT(3).value = ch_val; REF(3)DOT(2)DOT(4)DOT(3).tsdr
     = & dr_record;
/* move 3.2.4.3.0 5 */
  (*(REF(3)DOT(2)DOT(4)DOT(3)DOT(0).tsdr)->finalize)(
    REF(3)DOT(2)DOT(4)DOT(3)DOT(0).value,F_DISCARD,sched);
  REF(3)DOT(2)DOT(4)DOT(3)DOT(0) = REF(5);
  REF(5).tsdr = & dr_bottom;
/* new_table 3.2.4.3.1 , 3 */
  if ((ch_returncode = che_new_table(DEF(3)DOT(2)DOT(4)DOT(3)DOT(1),QUAL(3)
    ,sched)) != Normal)  goto ch_raise_exception;
/* unite 3.2.4.3.2 12 , 6 */
  if ((ch_returncode = che_unite(DEF(3)DOT(2)DOT(4)DOT(3)DOT(2),DEF(12),sched,
    6)) != Normal) goto ch_raise_exception;
/* return 3 */
  if (ch_caller = do_return(REF(3).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(3).value);
  REF(3).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
c68:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
